org.apache.solr.util

## Class RestTestBase

- java.lang.Object
- - org.junit.Assert
  - - org.apache.lucene.util.LuceneTestCase
    - - org.apache.solr.SolrTestCaseJ4
      - - org.apache.solr.SolrJettyTestBase
        - - org.apache.solr.util.RestTestBase

-     public abstract class RestTestBase
      extends SolrJettyTestBase

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.solr.SolrTestCaseJ4

      `SolrTestCaseJ4.CloudSolrClientBuilder, SolrTestCaseJ4.Doc, SolrTestCaseJ4.Fld, SolrTestCaseJ4.FldType, SolrTestCaseJ4.FVal, SolrTestCaseJ4.IRange, SolrTestCaseJ4.IVals, SolrTestCaseJ4.IValsPercent, SolrTestCaseJ4.SuppressObjectReleaseTracker, SolrTestCaseJ4.SuppressSSL, SolrTestCaseJ4.SVal, SolrTestCaseJ4.Vals, SolrTestCaseJ4.XmlDoc`

    - ### Nested classes/interfaces inherited from class org.apache.lucene.util.LuceneTestCase

      `org.apache.lucene.util.LuceneTestCase.AwaitsFix, org.apache.lucene.util.LuceneTestCase.BadApple, org.apache.lucene.util.LuceneTestCase.Monster, org.apache.lucene.util.LuceneTestCase.Nightly, org.apache.lucene.util.LuceneTestCase.Slow, org.apache.lucene.util.LuceneTestCase.SuppressCodecs, org.apache.lucene.util.LuceneTestCase.SuppressFileSystems, org.apache.lucene.util.LuceneTestCase.SuppressFsync, org.apache.lucene.util.LuceneTestCase.SuppressReproduceLine, org.apache.lucene.util.LuceneTestCase.SuppressSysoutChecks, org.apache.lucene.util.LuceneTestCase.SuppressTempFileChecks, org.apache.lucene.util.LuceneTestCase.ThrowingRunnable, org.apache.lucene.util.LuceneTestCase.Weekly`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static RestTestHarness` | `restTestHarness`

    - ### Fields inherited from class org.apache.solr.SolrJettyTestBase

      `client, context, jetty, port`

    - ### Fields inherited from class org.apache.solr.SolrTestCaseJ4

      `configString, CORE_PROPERTIES_FILENAME, DEFAULT_CONNECTION_TIMEOUT, DEFAULT_TEST_COLLECTION_NAME, DEFAULT_TEST_CORENAME, h, hdfsDataDir, initCoreDataDir, lrf, ONE_ONE, schemaString, solrClassRules, solrConfig, solrTestRules, sslConfig, SYSTEM_PROPERTY_SOLR_TESTS_MERGEPOLICY, SYSTEM_PROPERTY_SOLR_TESTS_MERGEPOLICYFACTORY, SYSTEM_PROPERTY_SOLR_TESTS_USEMERGEPOLICY, SYSTEM_PROPERTY_SOLR_TESTS_USEMERGEPOLICYFACTORY, testSolrHome, ZERO_ONE, ZERO_TWO`

    - ### Fields inherited from class org.apache.lucene.util.LuceneTestCase

      `assertsAreEnabled, classRules, DEFAULT_LINE_DOCS_FILE, INFOSTREAM, JENKINS_LARGE_LINE_DOCS_FILE, LEAVE_TEMPORARY, MAYBE_CACHE_POLICY, RANDOM_MULTIPLIER, ruleChain, suiteFailureMarker, SYSPROP_AWAITSFIX, SYSPROP_BADAPPLES, SYSPROP_FAILFAST, SYSPROP_MAXFAILURES, SYSPROP_MONSTER, SYSPROP_NIGHTLY, SYSPROP_SLOW, SYSPROP_WEEKLY, TEST_ASSERTS_ENABLED, TEST_AWAITSFIX, TEST_CODEC, TEST_DIRECTORY, TEST_DOCVALUESFORMAT, TEST_LINE_DOCS_FILE, TEST_NIGHTLY, TEST_POSTINGSFORMAT, TEST_SLOW, TEST_THROTTLING, TEST_WEEKLY, VERBOSE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RestTestBase()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `assertFailedU(String update)` Validates an update XML String failed
    `static void` | `assertFailedU(String message, String update)` Validates an update XML String failed
    `static void` | `assertJDelete(String request, double delta, String... tests)` Deletes a resource and then matches some JSON test expressions against the response using the specified double delta tolerance.
    `static void` | `assertJDelete(String request, String... tests)` Deletes a resource and then matches some JSON test expressions against the response using the default double delta tolerance.
    `static void` | `assertJPost(String request, String content, double delta, String... tests)` Validates the response from a PUT request matches some JSON test expressions and closes the query.
    `static void` | `assertJPost(String request, String content, String... tests)` Validates the response from a POST request matches some JSON test expressions
    `static void` | `assertJPut(String request, String content, double delta, String... tests)` Validates the response from a PUT request matches some JSON test expressions and closes the query.
    `static void` | `assertJPut(String request, String content, String... tests)` Validates the response from a PUT request matches some JSON test expressions
    `static void` | `assertJQ(String request, double delta, String... tests)` Validates a query matches some JSON test expressions and closes the query.
    `static void` | `assertJQ(String request, String... tests)` Validates a query matches some JSON test expressions using the default double delta tolerance.
    `static void` | `assertQ(String request, String... tests)` Validates a query matches some XPath test expressions
    `static void` | `assertU(String update)` Validates an update XML String is successful
    `static void` | `assertU(String message, String update)` Validates an update XML String is successful
    `static void` | `cleanUpHarness()`
    `static void` | `createJettyAndHarness(String solrHome, String configFile, String schemaFile, String context, boolean stopAtShutdown, SortedMap<org.eclipse.jetty.servlet.ServletHolder,String> extraServlets)`
    `static String` | `JQ(String request)` Makes a query request and returns the JSON string response

    - ### Methods inherited from class org.apache.solr.SolrJettyTestBase

      `afterSolrJettyTestBase, beforeSolrJettyTestBase, cleanUpJettyHome, createJetty, createJetty, createJetty, createJetty, createJetty, createNewSolrClient, getSolrClient, initCore, legacyExampleCollection1SolrHome, setupJettyTestHome`

    - ### Methods inherited from class org.apache.solr.SolrTestCaseJ4

      `add, addAndGetVersion, adoc, adoc, assertFieldValues, assertJQ, assertJQ, assertQ, assertQ, assertQEx, assertQEx, assertQEx, assertSolrInputFieldEquals, assertXmlFile, buildJettyConfig, buildUrl, chooseMPForMP, clearIndex, commit, compareSolrDocument, compareSolrDocumentList, compareSolrInputDocument, configset, copyMinConf, copyMinConf, copyMinFullSetup, copySolrHomeToTemp, createComparator, createComparator, createCore, createCoreContainer, createCoreContainer, createCoreContainer, createDefaultCoreContainer, createDoc, createSort, deleteAndGetVersion, deleteByQueryAndGetVersion, deleteCore, delI, delQ, doc, endTrackingSearchers, getClassName, getCloudSolrClient, getCloudSolrClient, getCloudSolrClient, getCloudSolrClient, getConcurrentUpdateSolrClient, getConcurrentUpdateSolrClient, getFile, getHttpSolrClient, getHttpSolrClient, getHttpSolrClient, getHttpSolrClient, getLBHttpSolrClient, getLBHttpSolrClient, getRootCause, getSchemaFile, getSimpleClassName, getSolrConfigFile, getWrappedException, hasInitException, hasInitException, ignoreException, indexDocs, initClassLogLevels, initCore, initCore, initCore, initMethodLogLevels, invertField, isSSLMode, JQ, json, json, json, jsonAdd, jsonDelId, jsonDelQ, map, newRandomConfig, optimize, params, postSetUp, preTearDown, randomDate, randomSkewedDate, randomXmlUsableUnicodeString, req, req, req, resetExceptionIgnores, resetFactory, restoreMethodLogLevels, sdoc, sdocs, setUp, setupNoCoreTest, setupTestCases, skewed, startTrackingSearchers, systemClearPropertySolrTestsMergePolicy, systemClearPropertySolrTestsMergePolicyFactory, systemSetPropertySolrTestsMergePolicy, systemSetPropertySolrTestsMergePolicyFactory, tearDown, teardownTestCases, TEST_HOME, TEST_PATH, toJSON, unchooseMPForMP, unIgnoreException, updateJ, useFactory, waitForWarming, whitespaceMockTokenizer, whitespaceMockTokenizer, writeCoreProperties, writeCoreProperties`

    - ### Methods inherited from class org.apache.lucene.util.LuceneTestCase

      `addVirusChecker, assertDeletedDocsEquals, assertDocsAndPositionsEnumEquals, assertDocsEnumEquals, assertDocsSkippingEquals, assertDocValuesEquals, assertDocValuesEquals, assertFieldInfosEquals, assertFieldsEquals, assertFieldStatisticsEquals, assertNormsEquals, assertPointsEquals, assertPositionsSkippingEquals, assertReaderEquals, assertReaderStatisticsEquals, assertStoredFieldEquals, assertStoredFieldsEquals, assertTermsEnumEquals, assertTermsEquals, assertTermsStatisticsEquals, assertTermStatsEquals, assertTermVectorsEquals, asSet, assumeFalse, assumeNoException, assumeTrue, atLeast, atLeast, closeAfterSuite, closeAfterTest, collate, createTempDir, createTempDir, createTempFile, createTempFile, dumpArray, dumpIterator, expectThrows, getBaseTempDirForTestClass, getDataInputStream, getDataPath, getOnlyLeafReader, getTestClass, getTestName, isTestThread, localeForLanguageTag, maybeChangeLiveIndexWriterConfig, maybeWrapReader, newAlcoholicMergePolicy, newAlcoholicMergePolicy, newDirectory, newDirectory, newDirectory, newDirectory, newDirectory, newField, newField, newFSDirectory, newFSDirectory, newIndexWriterConfig, newIndexWriterConfig, newIndexWriterConfig, newIOContext, newIOContext, newLogMergePolicy, newLogMergePolicy, newLogMergePolicy, newLogMergePolicy, newLogMergePolicy, newMaybeVirusCheckingDirectory, newMaybeVirusCheckingFSDirectory, newMergePolicy, newMergePolicy, newMockDirectory, newMockDirectory, newMockDirectory, newMockFSDirectory, newMockFSDirectory, newSearcher, newSearcher, newSearcher, newStringField, newStringField, newStringField, newStringField, newTextField, newTextField, newTieredMergePolicy, newTieredMergePolicy, overrideDefaultQueryCache, overrideTestDefaultQueryCache, random, randomLocale, randomTimeZone, rarely, rarely, replaceMaxFailureRule, resetDefaultQueryCache, restoreCPUCoreCount, restoreIndexWriterMaxDocs, restoreSpins, runWithRestrictedPermissions, setIndexWriterMaxDocs, setupCPUCoreCount, setupSpins, slowFileExists, usually, usually, wrapReader`

    - ### Methods inherited from class org.junit.Assert

      `assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertArrayEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertEquals, assertFalse, assertFalse, assertNotNull, assertNotNull, assertNotSame, assertNotSame, assertNull, assertNull, assertSame, assertSame, assertThat, assertThat, assertTrue, assertTrue, fail, fail`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### restTestHarness

          protected static RestTestHarness restTestHarness

  - ### Constructor Detail

    - #### RestTestBase

          public RestTestBase()

  - ### Method Detail

    - #### cleanUpHarness

          public static void cleanUpHarness()
                                     throws IOException

      Throws:
        `IOException`

    - #### createJettyAndHarness

          public static void createJettyAndHarness(String solrHome,
                                                   String configFile,
                                                   String schemaFile,
                                                   String context,
                                                   boolean stopAtShutdown,
                                                   SortedMap<org.eclipse.jetty.servlet.ServletHolder,String> extraServlets)
                                            throws Exception

      Throws:
        `Exception`

    - #### assertU

          public static void assertU(String update)

      Validates an update XML String is successful

    - #### assertU

          public static void assertU(String message,
                                     String update)

      Validates an update XML String is successful

    - #### assertFailedU

          public static void assertFailedU(String update)

      Validates an update XML String failed

    - #### assertFailedU

          public static void assertFailedU(String message,
                                           String update)

      Validates an update XML String failed

    - #### assertQ

          public static void assertQ(String request,
                                     String... tests)

      Validates a query matches some XPath test expressions
      Parameters:
        `request` - a URL path with optional query params, e.g. "/schema/fields?fl=id,_version_"

    - #### JQ

          public static String JQ(String request)
                           throws Exception

      Makes a query request and returns the JSON string response
      Parameters:
        `request` - a URL path with optional query params, e.g. "/schema/fields?fl=id,_version_"
      Throws:
        `Exception`

    - #### assertJQ

          public static void assertJQ(String request,
                                      String... tests)
                               throws Exception

      Validates a query matches some JSON test expressions using the default double delta tolerance.
      Throws:
        `Exception`
      See Also:
        `JSONTestUtil.DEFAULT_DELTA`, `assertJQ(String,double,String...)`

    - #### assertJQ

          public static void assertJQ(String request,
                                      double delta,
                                      String... tests)
                               throws Exception

      Validates a query matches some JSON test expressions and closes the query. The text expression is of the form path:JSON. To facilitate easy embedding in Java strings, the JSON can have double quotes replaced with single quotes.

      Please use this with care: this makes it easy to match complete structures, but doing so can result in fragile tests if you are matching more than what you want to test.

      Parameters:
        `request` - a URL path with optional query params, e.g. "/schema/fields?fl=id,_version_"
        `delta` - tolerance allowed in comparing float/double values
        `tests` - JSON path expression + '==' + expected value
      Throws:
        `Exception`

    - #### assertJPut

          public static void assertJPut(String request,
                                        String content,
                                        String... tests)
                                 throws Exception

      Validates the response from a PUT request matches some JSON test expressions
      Throws:
        `Exception`
      See Also:
        `JSONTestUtil.DEFAULT_DELTA`, `assertJQ(String,double,String...)`

    - #### assertJPut

          public static void assertJPut(String request,
                                        String content,
                                        double delta,
                                        String... tests)
                                 throws Exception

      Validates the response from a PUT request matches some JSON test expressions and closes the query. The text expression is of the form path==JSON. To facilitate easy embedding in Java strings, the JSON can have double quotes replaced with single quotes.

      Please use this with care: this makes it easy to match complete structures, but doing so can result in fragile tests if you are matching more than what you want to test.

      Parameters:
        `request` - a URL path with optional query params, e.g. "/schema/fields?fl=id,_version_"
        `content` - The content to include with the PUT request
        `delta` - tolerance allowed in comparing float/double values
        `tests` - JSON path expression + '==' + expected value
      Throws:
        `Exception`

    - #### assertJPost

          public static void assertJPost(String request,
                                         String content,
                                         String... tests)
                                  throws Exception

      Validates the response from a POST request matches some JSON test expressions
      Throws:
        `Exception`
      See Also:
        `JSONTestUtil.DEFAULT_DELTA`, `assertJQ(String,double,String...)`

    - #### assertJPost

          public static void assertJPost(String request,
                                         String content,
                                         double delta,
                                         String... tests)
                                  throws Exception

      Validates the response from a PUT request matches some JSON test expressions and closes the query. The text expression is of the form path==JSON. To facilitate easy embedding in Java strings, the JSON can have double quotes replaced with single quotes.

      Please use this with care: this makes it easy to match complete structures, but doing so can result in fragile tests if you are matching more than what you want to test.

      Parameters:
        `request` - a URL path with optional query params, e.g. "/schema/fields?fl=id,_version_"
        `content` - The content to include with the PUT request
        `delta` - tolerance allowed in comparing float/double values
        `tests` - JSON path expression + '==' + expected value
      Throws:
        `Exception`

    - #### assertJDelete

          public static void assertJDelete(String request,
                                           String... tests)
                                    throws Exception

      Deletes a resource and then matches some JSON test expressions against the response using the default double delta tolerance.
      Throws:
        `Exception`
      See Also:
        `JSONTestUtil.DEFAULT_DELTA`, `assertJDelete(String,double,String...)`

    - #### assertJDelete

          public static void assertJDelete(String request,
                                           double delta,
                                           String... tests)
                                    throws Exception

      Deletes a resource and then matches some JSON test expressions against the response using the specified double delta tolerance.
      Throws:
        `Exception`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.